// instrument by jscoverage, do not modifly this file
(function () {
  var BASE;
  if (typeof global === 'object') {
    BASE = global;
  } else if (typeof window === 'object') {
    BASE = window;
  } else {
    throw new Error('[jscoverage] unknow ENV!');
  }
  if (!BASE._$jscoverage) {
    BASE._$jscoverage = {};
    BASE._$jscoverage_cond = {};
    BASE._$jscoverage_done = function (file, line, express) {
      if (arguments.length === 2) {
        BASE._$jscoverage[file][line] ++;
      } else {
        BASE._$jscoverage_cond[file][line] ++;
        return express;
      }
    };
    BASE._$jscoverage_init = function (base, file, lines) {
      var tmp = [];
      for (var i = 0; i < lines.length; i ++) {
        tmp[lines[i]] = 0;
      }
      base[file] = tmp;
    };
  }
})();
_$jscoverage_init(_$jscoverage, "lib/nixt/runner.js",[5,11,12,13,14,15,71,71,72,73,74,75,76,77,89,90,91,103,104,105,117,118,119,133,134,135,148,149,150,162,163,164,165,165,166,177,178,179,180,191,192,193,204,205,206,217,218,219,230,231,232,243,244,245,256,257,258,269,270,271,283,284,285,296,297,298,309,310,311,322,323,323,324,334,335,345,346,347,360,361,362,373,374,376,377,378,379,380,381,381,383,392]);
_$jscoverage_init(_$jscoverage_cond, "lib/nixt/runner.js",[71,165,323,381]);
_$jscoverage["lib/nixt/runner.js"].source = ["/**"," * External dependencies."," */","","var clone = require('clone');","","/**"," * Internal dependencies."," */","","var Batch = require('./batch');","var Command = require('./command');","var Formatter = require('./formatter');","var expect = require('./expectations');","var middlewares = require('./middlewares');","","/**"," * The primary entry point for every Nixt test."," * It provides public interface that the users will interact with."," * Every `Runner` instance can be cloned and this way one can build"," * the so called \"templates\"."," *"," * Options:"," *"," *  - colors: default - true,       Strip colors from stdout and stderr when `false`"," *  - newlines: default - true,     Strip new lines from stdout and stderr when `false`"," *"," * Examples:"," *"," *  Instantiating the class:"," *"," *    nixt() // -> Runner"," *    new nixt // -> Runner"," *"," *  Simple stdout assertion:"," *"," *    nixt({ colors: false, newlines: false })"," *    .exec('todo clear')"," *    .exec('todo Buy milk')"," *    .run('todo ls')"," *    .stdout('Buy milk')"," *    .end(fn);"," *"," *  Stdout assertion:"," *"," *    nixt({ colors: false, newlines: false })"," *    .exec('todo clear')"," *    .run('todo')"," *    .stderr('Please enter a todo')"," *    .end(fn);"," *"," *  So repeating \"todo clear\" is simply ugly. You can avoid this by"," *  creating a \"template\"."," *"," *    var todo = nixt().before(clearTodos);"," *"," *  Later on:"," *"," *    todo.clone().exec..."," *"," * For more examples check the \"README\" file."," *"," * @see Batch"," * @see Formatter"," * @see Command"," * @param {Object} options"," * @constructor"," */","","function Runner(options) {","  if (!(this instanceof Runner)) return new Runner(options);","  options = options || {};","  this.options = options;","  this.formatter = new Formatter({ colors: options.colors, newlines: options.newlines });","  this.expectations = [];","  this.batch = new Batch;","  this.baseCmd = '';","}","","/**"," * Register a before filter."," *"," * @param {Function} fn"," * @returns {Runner} for chaining"," * @see Batch#addBefore"," * @api public"," */","","Runner.prototype.before = function(fn) {","  this.batch.addBefore(fn);","  return this;","};","","/**"," * Register an after filter."," *"," * @param {Function} fn"," * @returns {Runner} for chaining"," * @see Batch#addAfter"," * @api public"," */","","Runner.prototype.after = function(fn) {","  this.batch.addAfter(fn);","  return this;","};","","/**"," * Set the current working directory for"," * the command that will be executed."," *"," * @param {String} path"," * @returns {Runner} for chaining"," * @api public"," */","","Runner.prototype.cwd = function(path) {","  this.command().cwd(path);","  return this;","};","","/**"," * Specify a base command."," *"," * Very convenient when testing the same executable"," * again and again."," *"," * @param {String} command"," * @returns {Runner} for chaining"," * @api public"," */","","Runner.prototype.base = function(cmd) {","  this.baseCmd = cmd;","  return this;","};","","/**"," * Set environment variable."," *"," * @param {String} key"," * @param {String} value"," * @returns {Runner} for chaining"," * @see Command#env"," * @api public"," */","","Runner.prototype.env = function(key, val) {","  this.command().env(key, val);","  return this;","};","","/**"," * Specify a command to run."," *"," * @param {String} command"," * @returns {Runner} for chaining"," * @see Batch#main"," * @api public"," */","","Runner.prototype.run = function(cmd, fn) {","  this.command().set(this.baseCmd + cmd);","  this.batch.main(this.execFn());","  if (fn) this.end(fn);","  return this;","};","","/**"," * Force an execution timeout."," *"," * @param {Number} ms"," * @returns {Runner} for chaining"," * @api public"," */","","Runner.prototype.timeout = function(ms) {","  this.command().timeout(ms);","  this.expect(expect.time(ms));","  return this;","};","","/**"," * Register a \"stdout\" expectation."," *"," * @param {Regex|String} pattern"," * @returns {Runner} for chaining"," * @api public"," */","","Runner.prototype.stdout = function(pattern) {","  this.expect(expect.stdout(pattern));","  return this;","};","","/**"," * Register a \"stderr\" expectation."," *"," * @param {Regex|String} pattern"," * @returns {Runner} for chaining"," * @api public"," */","","Runner.prototype.stderr = function(pattern) {","  this.expect(expect.stderr(pattern));","  return this;","};","","/**"," * Register an exit code expectation."," *"," * @param {Number} code"," * @returns {Runner} for chaining"," * @api public"," */","","Runner.prototype.code = function(code) {","  this.expect(expect.code(code));","  return this;","};","","/**"," * Check if a file or a directory exists."," *"," * @param {String} path"," * @returns {Runner} for chaining"," * @api public"," */","","Runner.prototype.exist = function(path) {","  this.expect(expect.exists(path));","  return this;","};","","/**"," * Match the content of a file."," *"," * @param {Regex|String} pattern"," * @returns {Runner} for chaining"," * @api public"," */","","Runner.prototype.match = function(file, pattern) {","  this.expect(expect.match(file, pattern));","  return this;","};","","/**"," * Create a new directory."," *"," * @param {String} path"," * @returns {Runner} for chaining"," * @api public"," */","","Runner.prototype.mkdir = function(path) {","  this.batch.add(middlewares.mkdir(path));","  return this;","};","","/**"," * Execute a command."," *"," * @param {String} command"," * @returns {Runner} for chaining"," * @api public"," */","","Runner.prototype.exec = function(cmd) {","  this.batch.add(middlewares.exec(cmd));","  return this;","};","","/**"," * Create a new file with the given `content`."," *"," * @param {String} path"," * @param {String} data [optional]"," * @returns {Runner} for chaining"," * @api public"," */","","Runner.prototype.writeFile = function(path, data) {","  this.batch.add(middlewares.writeFile(path, data));","  return this;","};","","/**"," * Remove a directory."," *"," * @param {String} path"," * @returns {Runner} for chaining"," * @api public"," */","","Runner.prototype.rmdir = function(path) {","  this.batch.add(middlewares.rmdir(path));","  return this;","};","","/**"," * Remove a file."," *"," * @param {String} path"," * @returns {Runner} for chaining"," * @api public"," */","","Runner.prototype.unlink = function(path) {","  this.batch.add(middlewares.unlink(path));","  return this;","};","","/**"," * Run the test."," *"," * @param {Function} fn"," * @returns {Runner} for chaining"," * @api public"," */","","Runner.prototype.end = function(fn) {","  if (!this.batch.hasMain()) throw new Error('Please provide a command to run. Hint: `nixt#run`');","  this.batch.run(fn);","};","","/**"," * Clone the runner. Give basic support for templates."," *"," * @returns {Runner} clone of the current instance"," * @api public"," */","","Runner.prototype.clone = function() {","  return clone(this, false);","};","","/**"," * Register an expectation."," *"," * @param {Function} fn"," * @api public"," */","","Runner.prototype.expect = function(fn) {","  this.expectations.push(fn);","  return this;","};","","/**"," * Command factory."," *"," * Return the current command (or create a new one"," * if none exists yet)."," *"," * @returns {Command}"," * @api private"," */","","Runner.prototype.command = function() {","  this._command = this._command || new Command(this.formatter);","  return this._command;","};","","/**"," * Return a function that will execute"," * the command."," *"," * @returns {Function}"," * @api private"," */","","Runner.prototype.execFn = function() {","  var self = this;","","  return function(fn) {","    self.command().exec(function(result) {","      var err = null;","      for (var i = 0, len = self.expectations.length; i < len; i++) {","        err = self.expectations[i](result);","        if (err) break;","      }","      fn(err);","    });","  };","};","","/**"," * Primary export."," */","","module.exports = Runner;",""];
_$jscoverage_done("lib/nixt/runner.js", 5);
var clone = require("clone");

_$jscoverage_done("lib/nixt/runner.js", 11);
var Batch = require("./batch");

_$jscoverage_done("lib/nixt/runner.js", 12);
var Command = require("./command");

_$jscoverage_done("lib/nixt/runner.js", 13);
var Formatter = require("./formatter");

_$jscoverage_done("lib/nixt/runner.js", 14);
var expect = require("./expectations");

_$jscoverage_done("lib/nixt/runner.js", 15);
var middlewares = require("./middlewares");

function Runner(options) {
    _$jscoverage_done("lib/nixt/runner.js", 71);
    if (_$jscoverage_done("lib/nixt/runner.js", 71, !(this instanceof Runner))) {
        _$jscoverage_done("lib/nixt/runner.js", 71);
        return new Runner(options);
    }
    _$jscoverage_done("lib/nixt/runner.js", 72);
    options = options || {};
    _$jscoverage_done("lib/nixt/runner.js", 73);
    this.options = options;
    _$jscoverage_done("lib/nixt/runner.js", 74);
    this.formatter = new Formatter({
        colors: options.colors,
        newlines: options.newlines
    });
    _$jscoverage_done("lib/nixt/runner.js", 75);
    this.expectations = [];
    _$jscoverage_done("lib/nixt/runner.js", 76);
    this.batch = new Batch;
    _$jscoverage_done("lib/nixt/runner.js", 77);
    this.baseCmd = "";
}

_$jscoverage_done("lib/nixt/runner.js", 89);
Runner.prototype.before = function(fn) {
    _$jscoverage_done("lib/nixt/runner.js", 90);
    this.batch.addBefore(fn);
    _$jscoverage_done("lib/nixt/runner.js", 91);
    return this;
};

_$jscoverage_done("lib/nixt/runner.js", 103);
Runner.prototype.after = function(fn) {
    _$jscoverage_done("lib/nixt/runner.js", 104);
    this.batch.addAfter(fn);
    _$jscoverage_done("lib/nixt/runner.js", 105);
    return this;
};

_$jscoverage_done("lib/nixt/runner.js", 117);
Runner.prototype.cwd = function(path) {
    _$jscoverage_done("lib/nixt/runner.js", 118);
    this.command().cwd(path);
    _$jscoverage_done("lib/nixt/runner.js", 119);
    return this;
};

_$jscoverage_done("lib/nixt/runner.js", 133);
Runner.prototype.base = function(cmd) {
    _$jscoverage_done("lib/nixt/runner.js", 134);
    this.baseCmd = cmd;
    _$jscoverage_done("lib/nixt/runner.js", 135);
    return this;
};

_$jscoverage_done("lib/nixt/runner.js", 148);
Runner.prototype.env = function(key, val) {
    _$jscoverage_done("lib/nixt/runner.js", 149);
    this.command().env(key, val);
    _$jscoverage_done("lib/nixt/runner.js", 150);
    return this;
};

_$jscoverage_done("lib/nixt/runner.js", 162);
Runner.prototype.run = function(cmd, fn) {
    _$jscoverage_done("lib/nixt/runner.js", 163);
    this.command().set(this.baseCmd + cmd);
    _$jscoverage_done("lib/nixt/runner.js", 164);
    this.batch.main(this.execFn());
    _$jscoverage_done("lib/nixt/runner.js", 165);
    if (_$jscoverage_done("lib/nixt/runner.js", 165, fn)) {
        _$jscoverage_done("lib/nixt/runner.js", 165);
        this.end(fn);
    }
    _$jscoverage_done("lib/nixt/runner.js", 166);
    return this;
};

_$jscoverage_done("lib/nixt/runner.js", 177);
Runner.prototype.timeout = function(ms) {
    _$jscoverage_done("lib/nixt/runner.js", 178);
    this.command().timeout(ms);
    _$jscoverage_done("lib/nixt/runner.js", 179);
    this.expect(expect.time(ms));
    _$jscoverage_done("lib/nixt/runner.js", 180);
    return this;
};

_$jscoverage_done("lib/nixt/runner.js", 191);
Runner.prototype.stdout = function(pattern) {
    _$jscoverage_done("lib/nixt/runner.js", 192);
    this.expect(expect.stdout(pattern));
    _$jscoverage_done("lib/nixt/runner.js", 193);
    return this;
};

_$jscoverage_done("lib/nixt/runner.js", 204);
Runner.prototype.stderr = function(pattern) {
    _$jscoverage_done("lib/nixt/runner.js", 205);
    this.expect(expect.stderr(pattern));
    _$jscoverage_done("lib/nixt/runner.js", 206);
    return this;
};

_$jscoverage_done("lib/nixt/runner.js", 217);
Runner.prototype.code = function(code) {
    _$jscoverage_done("lib/nixt/runner.js", 218);
    this.expect(expect.code(code));
    _$jscoverage_done("lib/nixt/runner.js", 219);
    return this;
};

_$jscoverage_done("lib/nixt/runner.js", 230);
Runner.prototype.exist = function(path) {
    _$jscoverage_done("lib/nixt/runner.js", 231);
    this.expect(expect.exists(path));
    _$jscoverage_done("lib/nixt/runner.js", 232);
    return this;
};

_$jscoverage_done("lib/nixt/runner.js", 243);
Runner.prototype.match = function(file, pattern) {
    _$jscoverage_done("lib/nixt/runner.js", 244);
    this.expect(expect.match(file, pattern));
    _$jscoverage_done("lib/nixt/runner.js", 245);
    return this;
};

_$jscoverage_done("lib/nixt/runner.js", 256);
Runner.prototype.mkdir = function(path) {
    _$jscoverage_done("lib/nixt/runner.js", 257);
    this.batch.add(middlewares.mkdir(path));
    _$jscoverage_done("lib/nixt/runner.js", 258);
    return this;
};

_$jscoverage_done("lib/nixt/runner.js", 269);
Runner.prototype.exec = function(cmd) {
    _$jscoverage_done("lib/nixt/runner.js", 270);
    this.batch.add(middlewares.exec(cmd));
    _$jscoverage_done("lib/nixt/runner.js", 271);
    return this;
};

_$jscoverage_done("lib/nixt/runner.js", 283);
Runner.prototype.writeFile = function(path, data) {
    _$jscoverage_done("lib/nixt/runner.js", 284);
    this.batch.add(middlewares.writeFile(path, data));
    _$jscoverage_done("lib/nixt/runner.js", 285);
    return this;
};

_$jscoverage_done("lib/nixt/runner.js", 296);
Runner.prototype.rmdir = function(path) {
    _$jscoverage_done("lib/nixt/runner.js", 297);
    this.batch.add(middlewares.rmdir(path));
    _$jscoverage_done("lib/nixt/runner.js", 298);
    return this;
};

_$jscoverage_done("lib/nixt/runner.js", 309);
Runner.prototype.unlink = function(path) {
    _$jscoverage_done("lib/nixt/runner.js", 310);
    this.batch.add(middlewares.unlink(path));
    _$jscoverage_done("lib/nixt/runner.js", 311);
    return this;
};

_$jscoverage_done("lib/nixt/runner.js", 322);
Runner.prototype.end = function(fn) {
    _$jscoverage_done("lib/nixt/runner.js", 323);
    if (_$jscoverage_done("lib/nixt/runner.js", 323, !this.batch.hasMain())) {
        _$jscoverage_done("lib/nixt/runner.js", 323);
        throw new Error("Please provide a command to run. Hint: `nixt#run`");
    }
    _$jscoverage_done("lib/nixt/runner.js", 324);
    this.batch.run(fn);
};

_$jscoverage_done("lib/nixt/runner.js", 334);
Runner.prototype.clone = function() {
    _$jscoverage_done("lib/nixt/runner.js", 335);
    return clone(this, false);
};

_$jscoverage_done("lib/nixt/runner.js", 345);
Runner.prototype.expect = function(fn) {
    _$jscoverage_done("lib/nixt/runner.js", 346);
    this.expectations.push(fn);
    _$jscoverage_done("lib/nixt/runner.js", 347);
    return this;
};

_$jscoverage_done("lib/nixt/runner.js", 360);
Runner.prototype.command = function() {
    _$jscoverage_done("lib/nixt/runner.js", 361);
    this._command = this._command || new Command(this.formatter);
    _$jscoverage_done("lib/nixt/runner.js", 362);
    return this._command;
};

_$jscoverage_done("lib/nixt/runner.js", 373);
Runner.prototype.execFn = function() {
    _$jscoverage_done("lib/nixt/runner.js", 374);
    var self = this;
    _$jscoverage_done("lib/nixt/runner.js", 376);
    return function(fn) {
        _$jscoverage_done("lib/nixt/runner.js", 377);
        self.command().exec(function(result) {
            _$jscoverage_done("lib/nixt/runner.js", 378);
            var err = null;
            _$jscoverage_done("lib/nixt/runner.js", 379);
            for (var i = 0, len = self.expectations.length; i < len; i++) {
                _$jscoverage_done("lib/nixt/runner.js", 380);
                err = self.expectations[i](result);
                _$jscoverage_done("lib/nixt/runner.js", 381);
                if (_$jscoverage_done("lib/nixt/runner.js", 381, err)) {
                    _$jscoverage_done("lib/nixt/runner.js", 381);
                    break;
                }
            }
            _$jscoverage_done("lib/nixt/runner.js", 383);
            fn(err);
        });
    };
};

_$jscoverage_done("lib/nixt/runner.js", 392);
module.exports = Runner;